/**
  ******************************************************************************
  * @file    bsp_xxx.c
  * @author  fire
  * @version V1.0
  * @date    2013-xx-xx
  * @brief   2.4gģ/nrf24l01+/ Ӧbsp
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:Ұ iSO STM32  
  * ̳    :http://www.chuxue123.com
  * Ա    :http://firestm32.taobao.com
  *
  ******************************************************************************
  */ 
#include "bsp_spi_nrf.h"
#include "bsp_usart1.h"

 u8 RX_BUF[RX_PLOAD_WIDTH];		//ݻ
 u8 TX_BUF[TX_PLOAD_WIDTH];		//ݻ
 u8 TX_ADDRESS[TX_ADR_WIDTH] = {0x34,0x43,0x10,0x10,0x01};  // һ̬͵ַ
 u8 RX_ADDRESS[RX_ADR_WIDTH] = {0x34,0x43,0x10,0x10,0x01};

void Delay(__IO u32 nCount)
{
  for(; nCount != 0; nCount--);
} 

/**
  * @brief  SPI I/O
  * @param  
  * @retval 
  */
void SPI_NRF_Init(void)
{
  SPI_InitTypeDef  SPI_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  
  /*ӦIO˿ڵʱ*/
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA
                         |RCC_APB2Periph_GPIOC
                         |RCC_APB2Periph_GPIOE
                         |RCC_APB2Periph_GPIOG,ENABLE);

 /*ʹSPI1ʱ*/
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);

   /* SPI_NRF_SPI SCK,MISO,MOSIţGPIOA^5,GPIOA^6,GPIOA^7 */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; //ù
  GPIO_Init(GPIOA, &GPIO_InitStructure);  

  /*SPI_NRF_SPICE,SPI_NRF_SPI CSN */
#if 0
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8|GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOG, &GPIO_InitStructure);
#elif 1
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5|GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);
#endif

   /*SPI_NRF_SPIIRQ*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;  //
  GPIO_Init(GPIOC, &GPIO_InitStructure); 
		  
  /* Զĺ꣬csnţNRF״̬ */
  NRF_CSN_HIGH(); 
 
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; //˫ȫ˫
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;	 					//ģʽ
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	 				//ݴС8λ
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;		 				//ʱӼԣʱΪ
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;						//1ЧΪʱ
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		   					//NSSź
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;  //8Ƶ9MHz
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;  				//λǰ
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI1, &SPI_InitStructure);

  /* Enable SPI1  */
  SPI_Cmd(SPI1, ENABLE);
}


/**
  * @brief   NRF/дһֽ
  * @param   д
  *		@arg dat 
  * @retval  ȡõ
  */
u8 SPI_NRF_RW(u8 dat)
{  	
   /*  SPIͻǿʱȴ */
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);
  
   /* ͨ SPI2һֽ */
  SPI_I2S_SendData(SPI1, dat);		
 
   /* SPIջΪʱȴ */
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPI1);
}

/**
  * @brief   NRFضļĴд
  * @param   
  *		@arg reg:NRF+Ĵַ
  *		@arg dat:ҪĴд
  * @retval  NRFstatusĴ״̬
  */
u8 SPI_NRF_WriteReg(u8 reg,u8 dat)
{
 	u8 status;
	 NRF_CE_LOW();
	/*õCSNʹSPI*/
    NRF_CSN_LOW();
				
	/*Ĵ */
	status = SPI_NRF_RW(reg);
		 
	 /*Ĵд*/
    SPI_NRF_RW(dat); 
	          
	/*CSNߣ*/	   
  	NRF_CSN_HIGH();	
		
	/*״̬Ĵֵ*/
   	return(status);
}

/**
  * @brief   ڴNRFضļĴ
  * @param   
  *		@arg reg:NRF+Ĵַ
  * @retval  Ĵе
  */
u8 SPI_NRF_ReadReg(u8 reg)
{
 	u8 reg_val;

	NRF_CE_LOW();
	/*õCSNʹSPI*/
 	NRF_CSN_LOW();
				
  	 /*ͼĴ*/
	SPI_NRF_RW(reg); 

	 /*ȡĴֵ */
	reg_val = SPI_NRF_RW(NOP);
	            
   	/*CSNߣ*/
	NRF_CSN_HIGH();		
   	
	return reg_val;
}	

/**
  * @brief   NRFļĴдһ
  * @param   
  *		@arg reg : NRF+Ĵַ
  *		@arg pBufڴ洢ļĴݵ飬ⲿ
  * 	@arg bytes: pBufݳ
  * @retval  NRFstatusĴ״̬
  */
u8 SPI_NRF_ReadBuf(u8 reg,u8 *pBuf,u8 bytes)
{
 	u8 status, byte_cnt;

	  NRF_CE_LOW();
	/*õCSNʹSPI*/
	NRF_CSN_LOW();
		
	/*ͼĴ*/		
	status = SPI_NRF_RW(reg); 

 	/*ȡ*/
	 for(byte_cnt=0;byte_cnt<bytes;byte_cnt++)		  
	   pBuf[byte_cnt] = SPI_NRF_RW(NOP); //NRF24L01ȡ  

	 /*CSNߣ*/
	NRF_CSN_HIGH();	
		
 	return status;		//ؼĴ״ֵ̬
}

/**
  * @brief   NRFļĴдһ
  * @param   
  *		@arg reg : NRF+Ĵַ
  *		@arg pBuf洢˽ҪддĴݵ飬ⲿ
  * 	@arg bytes: pBufݳ
  * @retval  NRFstatusĴ״̬
  */
u8 SPI_NRF_WriteBuf(u8 reg ,u8 *pBuf,u8 bytes)
{
	 u8 status,byte_cnt;
	 NRF_CE_LOW();
   	 /*õCSNʹSPI*/
	 NRF_CSN_LOW();			

	 /*ͼĴ*/	
  	 status = SPI_NRF_RW(reg); 
 	
  	  /*򻺳д*/
	 for(byte_cnt=0;byte_cnt<bytes;byte_cnt++)
		SPI_NRF_RW(*pBuf++);	//дݵ 	 
	  	   
	/*CSNߣ*/
	NRF_CSN_HIGH();			
  
  	return (status);	//NRF24L01״̬ 		
}

/**
  * @brief  òģʽ
  * @param  
  * @retval 
  */
void NRF_RX_Mode(void)

{
	NRF_CE_LOW();	

   SPI_NRF_WriteBuf(NRF_WRITE_REG+RX_ADDR_P0,RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ

   SPI_NRF_WriteReg(NRF_WRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    

   SPI_NRF_WriteReg(NRF_WRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ    

   SPI_NRF_WriteReg(NRF_WRITE_REG+RF_CH,CHANAL);      //RFͨƵ    

   SPI_NRF_WriteReg(NRF_WRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ      

   SPI_NRF_WriteReg(NRF_WRITE_REG+RF_SETUP,0x0f); //TX,0db,2Mbps,濪   

   SPI_NRF_WriteReg(NRF_WRITE_REG+CONFIG, 0x0f);  //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 

/*CEߣģʽ*/	
  NRF_CE_HIGH();

}    

/**
  * @brief  ÷ģʽ
  * @param  
  * @retval 
  */
void NRF_TX_Mode(void)
{  
	NRF_CE_LOW();		

   SPI_NRF_WriteBuf(NRF_WRITE_REG+TX_ADDR,TX_ADDRESS,TX_ADR_WIDTH);    //дTXڵַ 

   SPI_NRF_WriteBuf(NRF_WRITE_REG+RX_ADDR_P0,RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK   

   SPI_NRF_WriteReg(NRF_WRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    

   SPI_NRF_WriteReg(NRF_WRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  

   SPI_NRF_WriteReg(NRF_WRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10

   SPI_NRF_WriteReg(NRF_WRITE_REG+RF_CH,CHANAL);       //RFͨΪCHANAL

   SPI_NRF_WriteReg(NRF_WRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
	
   SPI_NRF_WriteReg(NRF_WRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж

/*CEߣ뷢ģʽ*/	
  NRF_CE_HIGH();
    Delay(0xffff); //CEҪһʱŽ뷢ģʽ
}

/**
  * @brief  ҪNRFMCUǷ
  * @param  
  * @retval SUCCESS/ERROR /ʧ
  */
u8 NRF_Check(void)
{
	u8 buf[5]={0xC2,0xC2,0xC2,0xC2,0xC2};
	u8 buf1[5];
	u8 i; 
	 
	/*д5ֽڵĵַ.  */  
	SPI_NRF_WriteBuf(NRF_WRITE_REG+TX_ADDR,buf,5);

	/*дĵַ */
	SPI_NRF_ReadBuf(TX_ADDR,buf1,5); 
	 
	/*Ƚ*/               
	for(i=0;i<5;i++)
	{
		if(buf1[i]!=0xC2)
		break;
	} 
	       
	if(i==5)
		return SUCCESS ;        //MCUNRFɹ 
	else
		return ERROR ;        //MCUNRF
}

/**
  * @brief   NRFķͻд
  * @param   
  *		@arg txBuf洢˽Ҫ͵ݵ飬ⲿ	
  * @retval  ͽɹTXDS,ʧܷMAXRTERROR
  */
u8 NRF_Tx_Dat(u8 *txbuf)
{
	u8 state;  

	 /*ceΪͣģʽ1*/
	NRF_CE_LOW();

	/*дݵTX BUF  32ֽ*/						
   SPI_NRF_WriteBuf(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);

      /*CEΪߣtxbufǿգݰ */   
 	 NRF_CE_HIGH();
	  	
	  /*ȴж */                            
	while(NRF_Read_IRQ()!=0); 	
	
	/*ȡ״̬Ĵֵ */                              
	state = SPI_NRF_ReadReg(STATUS);

	 /*TX_DSMAX_RTжϱ־*/                  
	SPI_NRF_WriteReg(NRF_WRITE_REG+STATUS,state); 	

	SPI_NRF_WriteReg(FLUSH_TX,NOP);    //TX FIFOĴ 

	 /*жж*/    
	if(state&MAX_RT)                     //ﵽط
			 return MAX_RT; 

	else if(state&TX_DS)                  //
		 	return TX_DS;
	 else						  
			return ERROR;                 //ԭʧ
} 

/**
  * @brief   ڴNRFĽջж
  * @param   
  *		@arg rxBuf ڽոݵ飬ⲿ	
  * @retval 
  *		@arg ս
  */
u8 NRF_Rx_Dat(u8 *rxbuf)
{
	u8 state; 
	NRF_CE_HIGH();	 //״̬
	 /*ȴж*/
	while(NRF_Read_IRQ()!=0); 
	
	NRF_CE_LOW();  	 //״̬
	/*ȡstatusĴֵ  */               
	state=SPI_NRF_ReadReg(STATUS);
	 
	/* жϱ־*/      
	SPI_NRF_WriteReg(NRF_WRITE_REG+STATUS,state);

	/*жǷյ*/
	if(state&RX_DR)                                 //յ
	{
	  SPI_NRF_ReadBuf(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
	     SPI_NRF_WriteReg(FLUSH_RX,NOP);          //RX FIFOĴ
	  return RX_DR; 
	}
	else    
		return ERROR;                    //ûյκ
}


/**
  * @brief  SPI I/O
  * @param  
  * @retval 
  */
void SPI_NRF2_Init(void)
{
  SPI_InitTypeDef  SPI_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  
  /*ӦIO˿ڵʱ*/
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);

 /*ʹSPI1ʱ*/
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);

   /* SPI_NRF_SPI SCK,MISO,MOSIţGPIOA^13,GPIOA^14,GPIOA^15 */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; //ù
  GPIO_Init(GPIOB, &GPIO_InitStructure);  

  /*SPI_NRF_SPICE,SPI_NRF_SPI CSN */
   GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8|GPIO_Pin_12;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);


   /*SPI_NRF_SPIIRQ*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;  //
  GPIO_Init(GPIOB, &GPIO_InitStructure); 
		  
  /* Զĺ꣬csnţNRF״̬ */
  NRF2_CSN_HIGH(); 
 
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; //˫ȫ˫
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;	 					//ģʽ
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	 				//ݴС8λ
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;		 				//ʱӼԣʱΪ
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;						//1ЧΪʱ
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		   					//NSSź
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;  //8Ƶ9MHz
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;  				//λǰ
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI2, &SPI_InitStructure);

  /* Enable SPI2  */
  SPI_Cmd(SPI2, ENABLE);
}




/**
  * @brief   NRF/дһֽ
  * @param   д
  *		@arg dat 
  * @retval  ȡõ
  */
u8 SPI_NRF2_RW(u8 dat)
{  	
   /*  SPIͻǿʱȴ */
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);
  
   /* ͨ SPI2һֽ */
  SPI_I2S_SendData(SPI2, dat);		
 
   /* SPIջΪʱȴ */
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPI2);
}

/**
  * @brief   NRFضļĴд
  * @param   
  *		@arg reg:NRF+Ĵַ
  *		@arg dat:ҪĴд
  * @retval  NRFstatusĴ״̬
  */
u8 SPI_NRF2_WriteReg(u8 reg,u8 dat)
{
 	u8 status;
	 NRF2_CE_LOW();
	/*õCSNʹSPI*/
    NRF2_CSN_LOW();
				
	/*Ĵ */
	status = SPI_NRF2_RW(reg);
		 
	 /*Ĵд*/
    SPI_NRF2_RW(dat); 
	          
	/*CSNߣ*/	   
  	NRF2_CSN_HIGH();	
		
	/*״̬Ĵֵ*/
   	return(status);
}

/**
  * @brief   ڴNRFضļĴ
  * @param   
  *		@arg reg:NRF+Ĵַ
  * @retval  Ĵе
  */
u8 SPI_NRF2_ReadReg(u8 reg)
{
 	u8 reg_val;

	NRF2_CE_LOW();
	/*õCSNʹSPI*/
 	NRF2_CSN_LOW();
				
  	 /*ͼĴ*/
	SPI_NRF2_RW(reg); 

	 /*ȡĴֵ */
	reg_val = SPI_NRF2_RW(NOP);
	            
   	/*CSNߣ*/
	NRF2_CSN_HIGH();		
   	
	return reg_val;
}	

/**
  * @brief   NRFļĴдһ
  * @param   
  *		@arg reg : NRF+Ĵַ
  *		@arg pBufڴ洢ļĴݵ飬ⲿ
  * 	@arg bytes: pBufݳ
  * @retval  NRFstatusĴ״̬
  */
u8 SPI_NRF2_ReadBuf(u8 reg,u8 *pBuf,u8 bytes)
{
 	u8 status, byte_cnt;

	  NRF2_CE_LOW();
	/*õCSNʹSPI*/
	NRF2_CSN_LOW();
		
	/*ͼĴ*/		
	status = SPI_NRF2_RW(reg); 

 	/*ȡ*/
	 for(byte_cnt=0;byte_cnt<bytes;byte_cnt++)		  
	   pBuf[byte_cnt] = SPI_NRF2_RW(NOP); //NRF24L01ȡ  

	 /*CSNߣ*/
	NRF2_CSN_HIGH();	
		
 	return status;		//ؼĴ״ֵ̬
}

/**
  * @brief   NRFļĴдһ
  * @param   
  *		@arg reg : NRF+Ĵַ
  *		@arg pBuf洢˽ҪддĴݵ飬ⲿ
  * 	@arg bytes: pBufݳ
  * @retval  NRFstatusĴ״̬
  */
u8 SPI_NRF2_WriteBuf(u8 reg ,u8 *pBuf,u8 bytes)
{
	 u8 status,byte_cnt;
	 NRF2_CE_LOW();
   	 /*õCSNʹSPI*/
	 NRF2_CSN_LOW();			

	 /*ͼĴ*/	
  	 status = SPI_NRF2_RW(reg); 
 	
  	  /*򻺳д*/
	 for(byte_cnt=0;byte_cnt<bytes;byte_cnt++)
		SPI_NRF2_RW(*pBuf++);	//дݵ 	 
	  	   
	/*CSNߣ*/
	NRF2_CSN_HIGH();			
  
  	return (status);	//NRF24L01״̬ 		
}

/**
  * @brief  òģʽ
  * @param  
  * @retval 
  */
void NRF2_RX_Mode(void)

{
	NRF2_CE_LOW();	

   SPI_NRF2_WriteBuf(NRF_WRITE_REG+RX_ADDR_P0,RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ

   SPI_NRF2_WriteReg(NRF_WRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    

   SPI_NRF2_WriteReg(NRF_WRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ    

   SPI_NRF2_WriteReg(NRF_WRITE_REG+RF_CH,CHANAL);      //RFͨƵ    

   SPI_NRF2_WriteReg(NRF_WRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ      

   SPI_NRF2_WriteReg(NRF_WRITE_REG+RF_SETUP,0x0f); //TX,0db,2Mbps,濪   

   SPI_NRF2_WriteReg(NRF_WRITE_REG+CONFIG, 0x0f);  //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 

/*CEߣģʽ*/	
  NRF2_CE_HIGH();

}    

/**
  * @brief  ÷ģʽ
  * @param  
  * @retval 
  */
void NRF2_TX_Mode(void)
{  
	NRF2_CE_LOW();		

   SPI_NRF2_WriteBuf(NRF_WRITE_REG+TX_ADDR,TX_ADDRESS,TX_ADR_WIDTH);    //дTXڵַ 

   SPI_NRF2_WriteBuf(NRF_WRITE_REG+RX_ADDR_P0,RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK   

   SPI_NRF2_WriteReg(NRF_WRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    

   SPI_NRF2_WriteReg(NRF_WRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  

   SPI_NRF2_WriteReg(NRF_WRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10

   SPI_NRF2_WriteReg(NRF_WRITE_REG+RF_CH,CHANAL);       //RFͨΪCHANAL

   SPI_NRF2_WriteReg(NRF_WRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
	
   SPI_NRF2_WriteReg(NRF_WRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж

/*CEߣ뷢ģʽ*/	
  NRF2_CE_HIGH();
    Delay(0xffff); //CEҪһʱŽ뷢ģʽ
}

/**
  * @brief  ҪNRFMCUǷ
  * @param  
  * @retval SUCCESS/ERROR /ʧ
  */
u8 NRF2_Check(void)
{
	u8 buf[5]={0xC2,0xC2,0xC2,0xC2,0xC2};
	u8 buf1[5];
	u8 i; 
	 
	/*д5ֽڵĵַ.  */  
	SPI_NRF2_WriteBuf(NRF_WRITE_REG+TX_ADDR,buf,5);

	/*дĵַ */
	SPI_NRF2_ReadBuf(TX_ADDR,buf1,5); 
	 
	/*Ƚ*/               
	for(i=0;i<5;i++)
	{
		if(buf1[i]!=0xC2)
		break;
	} 
	       
	if(i==5)
		return SUCCESS ;        //MCUNRFɹ 
	else
		return ERROR ;        //MCUNRF
}

/**
  * @brief   NRFķͻд
  * @param   
  *		@arg txBuf洢˽Ҫ͵ݵ飬ⲿ	
  * @retval  ͽɹTXDS,ʧܷMAXRTERROR
  */
u8 NRF2_Tx_Dat(u8 *txbuf)
{
	u8 state;  

	 /*ceΪͣģʽ1*/
	NRF2_CE_LOW();

	/*дݵTX BUF  32ֽ*/						
   SPI_NRF2_WriteBuf(WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);

      /*CEΪߣtxbufǿգݰ */   
 	 NRF2_CE_HIGH();
	  	
	  /*ȴж */                            
	while(NRF2_Read_IRQ()!=0); 	
	
	/*ȡ״̬Ĵֵ */                              
	state = SPI_NRF2_ReadReg(STATUS);

	 /*TX_DSMAX_RTжϱ־*/                  
	SPI_NRF2_WriteReg(NRF_WRITE_REG+STATUS,state); 	

	SPI_NRF2_WriteReg(FLUSH_TX,NOP);    //TX FIFOĴ 

	 /*жж*/    
	if(state&MAX_RT)                     //ﵽط
			 return MAX_RT; 

	else if(state&TX_DS)                  //
		 	return TX_DS;
	 else						  
			return ERROR;                 //ԭʧ
} 

/**
  * @brief   ڴNRFĽջж
  * @param   
  *		@arg rxBuf ڽոݵ飬ⲿ	
  * @retval 
  *		@arg ս
  */
u8 NRF2_Rx_Dat(u8 *rxbuf)
{
	u8 state; 
	NRF2_CE_HIGH();	 //״̬
	 /*ȴж*/
	while(NRF2_Read_IRQ()!=0); 
	
	NRF2_CE_LOW();  	 //״̬
	/*ȡstatusĴֵ  */               
	state=SPI_NRF2_ReadReg(STATUS);
	 
	/* жϱ־*/      
	SPI_NRF2_WriteReg(NRF_WRITE_REG+STATUS,state);

	/*жǷյ*/
	if(state&RX_DR)                                 //յ
	{
	  SPI_NRF2_ReadBuf(RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
	     SPI_NRF2_WriteReg(FLUSH_RX,NOP);          //RX FIFOĴ
	  return RX_DR; 
	}
	else    
		return ERROR;                    //ûյκ
}


/*********************************************END OF FILE**********************/
